/*	Copyright (c) 1990, 1991 UNIX System Laboratories, Inc.	*/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF     	*/
/*	UNIX System Laboratories, Inc.                     	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	Copyright (c) 1993 USL
	All rights reserved

*/
#ifndef FML32_H
#define FML32_H

/* #ident	"@(#)fml:libfml/fml32.h	42.2" */
#ifndef TMENV_H
#include <tmenv.h>
#endif
#ifndef NOWHAT
static	char	h_fml32[] = "@(#)fml:libfml/fml32.h	42.2";
#endif

/*
 *	DEFINITIONS NEEDED BY USER APPLICATION PROGRAMS.
 *
 *	Warning: This header file should not be changed in any
 *	way; doing so will destroy the compatibility with TUXEDO programs
 *	and libraries.
 */

/*
 *	---------- Definitions and Macros ----------
 */

#define MAXFBLEN32	0x7ffffffe	/* Maximum FBFR3232 length */
#ifndef FML_H
#define FSTDXINT	16		/* Default indexing interval */
#define FMAXNULLSIZE	2660
#define FVIEWCACHESIZE	10
#define FVIEWNAMESIZE	33

/* operations presented to _Fmodidx function */
#define FADD	1
#undef FMOD
#define FMOD	2
#define FDEL	3

/* Flag options used in Fvstof() */
#define F_OFFSET	1
#define F_SIZE		2
#define F_PROP		4			/* P */
#define F_FTOS		8			/* S */
#define F_STOF		16			/* F */
#define F_BOTH		(F_STOF | F_FTOS)	/* S,F */
#define F_OFF		0			/* Z */
#define F_LENGTH        32                      /* L */
#define F_COUNT         64                      /* C */
#define F_NONE          128                     /* NONE flag for null value */

/* These are used in Fstof() */
#define FUPDATE		1
#define FCONCAT		2
#define FJOIN		3
#define FOJOIN		4

/* field types */
#define FLD_SHORT	0	/* short int */
#define FLD_LONG	1	/* long int */
#define FLD_CHAR	2	/* character */
#define FLD_FLOAT	3	/* single-precision float */
#define FLD_DOUBLE	4	/* double-precision float */
#define FLD_STRING	5	/* string - null terminated */
#define FLD_CARRAY	6	/* character array */


/* invalid field id - returned from functions where field id not found */
#define BADFLDID (FLDID32)0
/* define an invalid field id used for first call to Fnext */
#define FIRSTFLDID (FLDID32)0
#endif	/* FML_H */

/* definitions of macros for string conversions */

#define Fdel32(buffer,fieldid,oc)	Fchg32((buffer),(fieldid),(oc),NULL,0)
#define Fpres32(buffer,fieldid,oc)	(Ffind32((buffer),(fieldid),(oc),NULL)\
						!= NULL)
	/* add string value to buf */
#define Fadds32(fb,id,uval) CFadd32((fb),(id),(uval),0,FLD_STRING)

	/* change ocurrance .. supplied val is a string */
#define Fchgs32(fb,id,oc,uval) CFchg32((fb),(id),(oc),(uval),0,FLD_STRING)

	/* get value, as a string into usr buffer */
#define Fgets32(fb,id,oc,ubuf) CFget32((fb),(id),(oc),(ubuf),0,FLD_STRING)

	/* get value, as a string, into malloced buffer */
#define Fgetsa32(fb,id,oc,xtra) ((char *)CFgetalloc32((fb),(id),(oc), \
					FLD_STRING,xtra))

	/* return pointer to string value of field */
#define Ffinds32(fb,id,oc) ((char *)CFfind32((fb),(id),(oc),0,FLD_STRING))


/* Field Error Codes - these correspond to the error messages in
 *			F_error.c - make sure to update the error
 *			message list if a new error is added
 */
#ifndef FML_H
#define FMINVAL 0		/* bottom of error message codes */
#define FALIGNERR 1		/* fielded buffer not aligned */
#define FNOTFLD 2		/* buffer not fielded */
#define FNOSPACE 3		/* no space in fielded buffer */
#define FNOTPRES 4		/* field not present */
#define FBADFLD 5		/* unknown field number or type */
#define FTYPERR 6               /* illegal field type */
#define FEUNIX 7		/* unix system call error */
#define FBADNAME 8		/* unknown field name */
#define FMALLOC 9		/* malloc failed */
#define FSYNTAX 10		/* bad syntax in boolean expression */
#define FFTOPEN 11		/* cannot find or open field table */
#define FFTSYNTAX 12		/* syntax error in field table */
#define FEINVAL 13		/* invalid argument to function */
#define FBADTBL 14      	/* destructive concurrent access to field
				   table */
#define FBADVIEW 15		/* cannot find or get view */
#define FVFSYNTAX 16		/* bad viewfile */
#define FVFOPEN 17		/* cannot find or open viewfile */
#define FBADACM 18              /* ACM contains negative value */
#define FNOCNAME 19             /* cname not found */
#define FMAXVAL  20 		/* top of error message codes */
#endif /* FML_H */



/*
 *	---------- Type Definitions ----------
 */

/* another typedef of FLDID/FLDLEN exists in tuxedo/include/tmbase.h */
#ifndef _FLDID32
#define _FLDID32
typedef TM32U FLDID32;
typedef TM32U FLDLEN32;
typedef TM32I FLDOCC32;
#endif
typedef struct Fbfr32 FBFR32;

/*
 *	---------- External declarations ----------
 */

extern	char	*Femsgs32[];

#if defined(_TMDOWN)
/* handle case-insensitive link conflict for globals and functions */
#define Fread32(A,B) FMLread32(A,B)
#define Fwrite32(A,B) FMLwrite32(A,B)
#endif

#if (defined(_TM_WIN) || defined(_TM_OS2) || defined(WIN32)) && !defined(_TMDLL)

#if defined(__cplusplus)
extern "C" {
#endif
extern int _TM_FAR * _TMDLLENTRY _Fget_Ferror_addr32(void);
extern int _TMDLLENTRY getFerror32(void);
#if defined(__cplusplus)
}
#endif

#define Ferror32	(*_Fget_Ferror_addr32())
#else
#if defined(_TMDOWN)
/* handle case-insensitive link conflict for Ferror */
#define Ferror32	FMLerror32
extern int FMLerror32;
#else
extern int Ferror32;
#endif
#endif

#ifdef _TMPROTOTYPES
#include <stdio.h>
#endif



#if defined(__cplusplus)
extern "C" {
#endif

#if defined(_TMDOWN)
/* handle case-insensitive link conflict for and functions */
extern int _TMDLLENTRY FMLread32 _((FBFR32 _TM_FAR *, FILE _TM_FAR *));
extern int _TMDLLENTRY FMLwrite32 _((FBFR32 _TM_FAR *, FILE _TM_FAR *));
#else
extern int Fread32 _((FBFR32 *, FILE *));
extern int Fwrite32 _((FBFR32 *, FILE *));
#endif

extern int _TMDLLENTRY CFadd32 _((FBFR32 _TM_FAR *, FLDID32, char _TM_FAR*,
	FLDLEN32, int));
extern int _TMDLLENTRY CFchg32 _((FBFR32 _TM_FAR *, FLDID32, FLDOCC32,
	char _TM_FAR *, FLDLEN32, int ));
extern char _TM_FAR * _TMDLLENTRY CFfind32 _((FBFR32 _TM_FAR *, FLDID32,
	FLDOCC32, FLDLEN32 _TM_FAR *, int));
extern FLDOCC32 _TMDLLENTRY CFfindocc32 _((FBFR32 _TM_FAR *, FLDID32,
	char _TM_FAR *, FLDLEN32, int ));
extern int _TMDLLENTRY CFget32 _((FBFR32 _TM_FAR *, FLDID32, FLDOCC32,
	char _TM_FAR *, FLDLEN32 _TM_FAR *, int ));
extern char _TM_FAR * _TMDLLENTRY CFgetalloc32 _((FBFR32 _TM_FAR *, FLDID32,
	FLDOCC32, int, FLDLEN32 _TM_FAR *));
extern void F_error32 _((char *));
extern int _TMDLLENTRY Fadd32 _((FBFR32 _TM_FAR *, FLDID32, char _TM_FAR *,
	FLDLEN32));
extern FBFR32 _TM_FAR * _TMDLLENTRY Falloc32 _((FLDOCC32, FLDLEN32));
extern FBFR32 _TM_FAR * _TMDLLENTRY Frealloc32 _((FBFR32 _TM_FAR *, FLDOCC32,
	FLDLEN32));
extern int _TMDLLENTRY Ffree32 _((FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fboolev32 _((FBFR32 _TM_FAR *, char _TM_FAR *));
extern double _TMDLLENTRY Ffloatev32 _((FBFR32 _TM_FAR *, char _TM_FAR *));
extern void _TMDLLENTRY Fboolpr32 _((char _TM_FAR *, FILE _TM_FAR *));
extern int _TMDLLENTRY Fchg32 _((FBFR32 _TM_FAR *, FLDID32, FLDOCC32,
	char _TM_FAR *, FLDLEN32));
extern long _TMDLLENTRY Fchksum32 _((FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fcmp32 _((FBFR32 _TM_FAR *, FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fconcat32 _((FBFR32 _TM_FAR *, FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fcpy32 _((FBFR32 _TM_FAR *,FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fdelall32 _((FBFR32 _TM_FAR *, FLDID32));
extern int _TMDLLENTRY Fdelete32 _((FBFR32 _TM_FAR *, FLDID32 _TM_FAR *));
extern int _TMDLLENTRY Fextread32 _((FBFR32 _TM_FAR *, FILE _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Ffind32 _((FBFR32 _TM_FAR *, FLDID32,
	FLDOCC32, FLDLEN32 _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Fvals32 _((FBFR32 _TM_FAR *, FLDID32,
	FLDOCC32 ));
extern long _TMDLLENTRY Fvall32 _((FBFR32 _TM_FAR *, FLDID32, FLDOCC32 ));
extern FLDOCC32 _TMDLLENTRY Ffindocc32 _((FBFR32 _TM_FAR *, FLDID32,
	char _TM_FAR *, FLDLEN32 ));
extern int _TMDLLENTRY Fget32 _((FBFR32 _TM_FAR *, FLDID32, FLDOCC32,
	char _TM_FAR *, FLDLEN32 _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Fgetalloc32 _((FBFR32 _TM_FAR *, FLDID32,
	FLDOCC32, FLDLEN32 _TM_FAR *));
extern int _TMDLLENTRY Fldtype32 _((FLDID32));
extern int _TMDLLENTRY Fldno32 _((FLDID32));
extern int _TMDLLENTRY Fielded32 _((FBFR32 _TM_FAR *));
extern long _TMDLLENTRY Fneeded32 _((FLDOCC32, FLDLEN32));
extern long _TMDLLENTRY Fused32 _((FBFR32 _TM_FAR *));
extern long _TMDLLENTRY Fidxused32 _((FBFR32 _TM_FAR *));
extern long _TMDLLENTRY Funused32 _((FBFR32 _TM_FAR *));
extern long _TMDLLENTRY Fsizeof32 _((FBFR32 _TM_FAR *));
extern FLDID32 _TMDLLENTRY Fmkfldid32 _((int, FLDID32 ));
extern FLDLEN32 _TMDLLENTRY Fieldlen32 _((char _TM_FAR *, FLDLEN32 _TM_FAR *,
	FLDLEN32 _TM_FAR *));
extern FLDOCC32 _TMDLLENTRY Funindex32 _((FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Frstrindex32 _((FBFR32 _TM_FAR *, FLDOCC32 ));
extern int _TMDLLENTRY Findex32 _((FBFR32 _TM_FAR *, FLDOCC32 ));
extern int _TMDLLENTRY Finit32 _((FBFR32 _TM_FAR *, FLDLEN32));
extern int _TMDLLENTRY Fjoin32 _((FBFR32 _TM_FAR *, FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fojoin32 _((FBFR32 _TM_FAR *, FBFR32 _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Ffindlast32 _((FBFR32 _TM_FAR *, FLDID32,
	FLDOCC32 _TM_FAR *, FLDLEN32 _TM_FAR *));
extern int _TMDLLENTRY Fgetlast32 _((FBFR32 _TM_FAR *, FLDID32,
	FLDOCC32 _TM_FAR *, char _TM_FAR *, FLDLEN32 _TM_FAR *));
extern long _TMDLLENTRY Flen32 _((FBFR32 _TM_FAR *, FLDID32, FLDOCC32 ));
extern int _TMDLLENTRY Fmove32 _((char _TM_FAR *, FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fnext32 _((FBFR32 _TM_FAR *, FLDID32 _TM_FAR *,
	FLDOCC32 _TM_FAR *, char _TM_FAR *, FLDLEN32 _TM_FAR *));
extern FLDID32 _TMDLLENTRY Fldid32 _((char _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Fname32 _((FLDID32));
extern char _TM_FAR * _TMDLLENTRY Ftype32 _((FLDID32));
extern void _TMDLLENTRY Fnmid_unload32 _((void));
extern void _TMDLLENTRY Fidnm_unload32 _((void));
extern FLDOCC32 _TMDLLENTRY Fnum32 _((FBFR32 _TM_FAR *));
extern FLDOCC32 _TMDLLENTRY Foccur32 _((FBFR32 _TM_FAR *, FLDID32 ));
extern int Fprint32 _((FBFR32 *));
extern int _TMDLLENTRY Ffprint32 _((FBFR32 _TM_FAR *, FILE _TM_FAR *));
extern int _TMDLLENTRY Fproj32 _((FBFR32 _TM_FAR *, FLDID32 _TM_FAR *));
extern int _TMDLLENTRY Fprojcpy32 _((FBFR32 _TM_FAR *, FBFR32 _TM_FAR *,
	FLDID32 _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Ftypcvt32 _((FLDLEN32 _TM_FAR *, int,
	char _TM_FAR *, int, FLDLEN32 ));
extern int _TMDLLENTRY Fupdate32 _((FBFR32 _TM_FAR *, FBFR32 _TM_FAR *));
extern int _TMDLLENTRY Fvopt32 _((char _TM_FAR *, int, char _TM_FAR *));
extern int _TMDLLENTRY Fvsinit32 _((char _TM_FAR *, char _TM_FAR *));
extern int _TMDLLENTRY Fvnull32 _((char _TM_FAR *, char _TM_FAR *, FLDOCC32,
	char _TM_FAR *));
extern int _TMDLLENTRY Fvselinit32 _((char _TM_FAR *, char _TM_FAR *,
	char _TM_FAR *));
extern int _TMDLLENTRY Fvftos32 _((FBFR32 _TM_FAR *, char _TM_FAR *,
	char _TM_FAR *));
extern int _TMDLLENTRY Fvstof32 _((FBFR32 _TM_FAR *, char _TM_FAR *, int,
	char _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Fboolco32 _((char _TM_FAR *));
extern char _TM_FAR * _TMDLLENTRY Fstrerror32 _((int));
extern int  _TMDLLENTRY maskprt32 _((FBFR32 _TM_FAR *));

#ifdef FML_H
extern int _TMDLLENTRY F16to32 _((FBFR32 _TM_FAR *dbfr, FBFR _TM_FAR *sbfr));
extern int _TMDLLENTRY F32to16 _((FBFR _TM_FAR *dbfr, FBFR32 _TM_FAR *sbfr));
#endif

#if defined(__cplusplus)
}
#endif
/* typed-buffer types */
#define FMLTYPE32 "FML32"
#define VIEWTYPE32 "VIEW32"

#endif
